<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Constructors</title>
</head>
<body>
  <div class="wrap"></div>
  <script>
  /*

    Задание:

    Написать функцию конструктор, которая будет иметь приватные и публичные свойства.
    Публичные методы должны вызывать приватные.

    Рассмотрим на примере планеты:

      - На вход принимаются параметр Имя планеты.

      Создается новый обьект, который имеет публичные методы и свойства:
      - name (передается через конструктор)
      - population ( randomPopulation());
      - rotatePlanet(){
        let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
        if ( (randomNumber % 2) == 0) {
          growPopulation();
        } else {
          Cataclysm();
        }
      }

      Приватное свойство:
      populationMultiplyRate - случайное число от 1 до 10;

      Приватные методы
      randomPopulation -> Возвращает случайное целое число от 1.000 до 10.000
      growPopulation() {
        функция которая берет приватное свойство populationMultiplyRate
        которое равняется случайному числу от 1 до 10 и умножает его на 100.
        Дальше, число которое вышло добавляет к популяции и выводит в консоль сообщение,
        что за один цикл прибавилось столько населения на планете .
      }
      Cataclysm(){
        Рандомим число от 1 до 10 и умножаем его на 10000;
        То число которое получили, отнимаем от популяции.
        В консоль выводим сообщение - от катаклизма погибло Х человек на планете.
      }
      
  */
    function generatePlanet(name){
      this.name = name;
      this.population = GenerateRandomNum(10000);

      function GenerateRandomNum( q ){
      return Math.floor( Math.random() * q);
    }

      function getRandomIntInclusive(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }

      this.rotatePlanet = () => {
        let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
        if ( (randomNumber % 2) == 0) {
          growPopulation();
        } else {
          Cataclysm();
          }
        };

      let populationMultiplyRate = getRandomIntInclusive(1,10);

      const randomPopulation = () => {
        return getRandomIntInclusive(1000,10000)
      }

      const growPopulation = () => {
        let populationMultiplyRateBy100 = populationMultiplyRate * 100;
        let growPopulationNumber = populationMultiplyRateBy100 + this.population;
        console.log("За один цикл прибавилось "+ growPopulationNumber +" населения на планете ");

      }

      const Cataclysm = () => {
        let number = getRandomIntInclusive(1, 10);
        let numberMultiBy10000 = number*1000;
        let x = this.population-numberMultiBy10000;
        if (x < 0){
          console.log("Человечество на планете",this.name,"вымерло!");
        }else{
          console.log("От катаклизма погибло "+ x +" человек на планете");
        }
      }

    }
    let Planet1 = new generatePlanet("LALALA");
    Planet1.rotatePlanet();

  </script>
</body>
</html>
